class I3D(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  name : str
  num_classes : int
  modality : str
  conv3d_1a_7x7 : __torch__.src.i3dpt_jit.Unit3Dpy
  maxPool3d_2a_3x3 : __torch__.src.i3dpt_jit.MaxPool3dTFPadding
  conv3d_2b_1x1 : __torch__.src.i3dpt_jit.___torch_mangle_5.Unit3Dpy
  conv3d_2c_3x3 : __torch__.src.i3dpt_jit.___torch_mangle_8.Unit3Dpy
  maxPool3d_3a_3x3 : __torch__.src.i3dpt_jit.MaxPool3dTFPadding
  mixed_3b : __torch__.src.i3dpt_jit.Mixed
  mixed_3c : __torch__.src.i3dpt_jit.___torch_mangle_44.Mixed
  maxPool3d_4a_3x3 : __torch__.src.i3dpt_jit.___torch_mangle_49.MaxPool3dTFPadding
  mixed_4b : __torch__.src.i3dpt_jit.___torch_mangle_67.Mixed
  mixed_4c : __torch__.src.i3dpt_jit.___torch_mangle_87.Mixed
  mixed_4d : __torch__.src.i3dpt_jit.___torch_mangle_94.Mixed
  mixed_4e : __torch__.src.i3dpt_jit.___torch_mangle_107.Mixed
  mixed_4f : __torch__.src.i3dpt_jit.___torch_mangle_124.Mixed
  maxPool3d_5a_2x2 : __torch__.src.i3dpt_jit.___torch_mangle_129.MaxPool3dTFPadding
  mixed_5b : __torch__.src.i3dpt_jit.___torch_mangle_141.Mixed
  mixed_5c : __torch__.src.i3dpt_jit.___torch_mangle_155.Mixed
  avg_pool : __torch__.torch.nn.modules.pooling.AvgPool3d
  dropout : __torch__.torch.nn.modules.dropout.Dropout
  conv3d_0c_1x1 : __torch__.src.i3dpt_jit.___torch_mangle_157.Unit3Dpy
  softmax : __torch__.torch.nn.modules.activation.Softmax
  def forward(self: __torch__.src.i3dpt_jit.I3D,
    x: Tensor,
    rescale: bool=False,
    resize: bool=False,
    return_features: bool=False) -> Tensor:
    _0 = __torch__.torch.nn.functional.___torch_mangle_158.interpolate
    if rescale:
      x1 = torch.sub(torch.mul(torch.div(x, 255), 2), 1, 1)
      x0 = x1
    else:
      x0 = x
    if resize:
      b, c, t, h, w, = torch.size(x0)
      x3 = _0(torch.view(x0, [b, -1, h, w]), [224, 224], None, "bilinear", False, None, )
      x4 = torch.view(x3, [b, c, t, 224, 224])
      x2 = x4
    else:
      x2 = x0
    out = (self.conv3d_1a_7x7).forward(x2, )
    out0 = (self.maxPool3d_2a_3x3).forward(out, )
    out1 = (self.conv3d_2b_1x1).forward(out0, )
    out2 = (self.conv3d_2c_3x3).forward(out1, )
    out3 = (self.maxPool3d_3a_3x3).forward(out2, )
    out4 = (self.mixed_3b).forward(out3, )
    out5 = (self.mixed_3c).forward(out4, )
    out6 = (self.maxPool3d_4a_3x3).forward(out5, )
    out7 = (self.mixed_4b).forward(out6, )
    out8 = (self.mixed_4c).forward(out7, )
    out9 = (self.mixed_4d).forward(out8, )
    out10 = (self.mixed_4e).forward(out9, )
    out11 = (self.mixed_4f).forward(out10, )
    out12 = (self.maxPool3d_5a_2x2).forward(out11, )
    out13 = (self.mixed_5b).forward(out12, )
    out14 = (self.mixed_5c).forward(out13, )
    out15 = (self.avg_pool).forward(out14, )
    out16 = (self.dropout).forward(out15, )
    out17 = (self.conv3d_0c_1x1).forward(out16, )
    out18 = torch.squeeze(out17, 3)
    out19 = torch.squeeze(out18, 3)
    out20 = torch.mean(out19, [2], False, dtype=None)
    out21 = (self.softmax).forward(out20, )
    if return_features:
      _1 = out20
    else:
      _1 = out21
    return _1
class Unit3Dpy(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  padding : str
  use_bn : bool
  stride : Tuple[int, int, int]
  simplify_pad : bool
  pads : __torch__.torch.nn.modules.container.ModuleList
  conv3d : __torch__.torch.nn.modules.conv.Conv3d
  batch3d : __torch__.torch.nn.modules.batchnorm.BatchNorm3d
  activation : __torch__.torch.nn.modules.activation.ReLU
  def forward(self: __torch__.src.i3dpt_jit.Unit3Dpy,
    inp: Tensor) -> Tensor:
    if torch.eq(self.padding, "SAME"):
      _3 = torch.__is__(self.simplify_pad, False)
      _2 = _3
    else:
      _2 = False
    if _2:
      _4 = torch.remainder((torch.size(inp))[2], (self.stride)[0])
      if torch.eq(_4, 0):
        inp2 = (getattr(self.pads, "0")).forward(inp, )
        inp1 = inp2
      else:
        _5 = torch.remainder((torch.size(inp))[2], (self.stride)[0])
        if torch.eq(_5, 1):
          inp4 = (getattr(self.pads, "1")).forward(inp, )
          inp3 = inp4
        else:
          inp3 = inp
        inp1 = inp3
      inp0 = inp1
    else:
      inp0 = inp
    out = (self.conv3d).forward(inp0, )
    if self.use_bn:
      out22 = (self.batch3d).forward(out, )
    else:
      out22 = out
    out23 = __torch__.torch.nn.functional.relu(out22, False, )
    return out23
class MaxPool3dTFPadding(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  padding_shape : Tuple[int, int, int, int, int, int]
  stride : Tuple[int, int, int]
  pads : __torch__.torch.nn.modules.container.___torch_mangle_2.ModuleList
  pool : __torch__.torch.nn.modules.pooling.MaxPool3d
  def forward(self: __torch__.src.i3dpt_jit.MaxPool3dTFPadding,
    inp: Tensor) -> Tensor:
    _6 = torch.remainder((torch.size(inp))[2], (self.stride)[0])
    if torch.eq(_6, 0):
      inp6 = (getattr(self.pads, "0")).forward(inp, )
      inp5 = inp6
    else:
      _7 = torch.remainder((torch.size(inp))[2], (self.stride)[0])
      if torch.eq(_7, 1):
        inp8 = (getattr(self.pads, "1")).forward(inp, )
        inp7 = inp8
      else:
        inp7 = inp
      inp5 = inp7
    return (self.pool).forward(inp5, )
class Mixed(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  branch_0 : __torch__.src.i3dpt_jit.___torch_mangle_10.Unit3Dpy
  branch_1 : __torch__.torch.nn.modules.container.Sequential
  branch_2 : __torch__.torch.nn.modules.container.___torch_mangle_23.Sequential
  branch_3 : __torch__.torch.nn.modules.container.___torch_mangle_30.Sequential
  def forward(self: __torch__.src.i3dpt_jit.Mixed,
    inp: Tensor) -> Tensor:
    out_0 = (self.branch_0).forward(inp, )
    out_1 = (self.branch_1).forward(inp, )
    out_2 = (self.branch_2).forward(inp, )
    out_3 = (self.branch_3).forward(inp, )
    out = torch.cat([out_0, out_1, out_2, out_3], 1)
    return out
